﻿Friend Class Form_MultiColumnComboBoxDropDown

    Friend Event Selected()
    Private SelectedIndex As Integer = -1

    Private Sub Form_MultiColumnComboBoxDropDown_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        DoubleBuffered = True
    End Sub

    Private Sub ListView1_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ListView1.MouseUp
        If e.Button = Forms.MouseButtons.Left Then
            If ListView1.SelectedItems.Count > 0 Then RaiseEvent Selected()
        End If
    End Sub

    Private Sub ListView1_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles ListView1.KeyDown
        If e.KeyCode = Keys.Down Then
            If SelectedIndex < ListView1.Items.Count - 1 Then
                ListView1.Items(SelectedIndex + 1).Selected = True
                e.Handled = True
            End If
        ElseIf e.KeyCode = Keys.Up Then
            If SelectedIndex > 0 Then
                ListView1.Items(SelectedIndex - 1).Selected = True
                e.Handled = True
            End If
        ElseIf e.KeyCode = Keys.Enter OrElse e.KeyCode = Keys.Space Then
            If ListView1.SelectedItems.Count > 0 Then
                RaiseEvent Selected()
                e.Handled = True
            End If
        End If
    End Sub

    Private Sub ListView1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListView1.SelectedIndexChanged
        Dim enumerator = ListView1.SelectedIndices.GetEnumerator
        If enumerator.MoveNext Then
            SelectedIndex = enumerator.Current
        Else
            SelectedIndex = -1
        End If
    End Sub
End Class