﻿Imports System.Windows.Forms.MultiColumnComboBox

Public Class Form1

    Private Sub MultiColumnComboBox1_DropdownRequested(ByVal sender As Object, ByVal e As MultiColumnComboBox.DropdownRequestEventArgs) Handles MultiColumnComboBox1.DropdownRequested
        If MultiColumnComboBox1.Values.Count = 0 Then
            With MultiColumnComboBox1
                With .Titles
                    .Clear()
                    If True Then
                        Dim c As New TitleStructure
                        c.Align = HorizontalAlignment.Left
                        c.HeaderName = "First"
                        c.Width = 50
                        .Add(c)
                    End If
                    If True Then
                        Dim c As New TitleStructure
                        c.Align = HorizontalAlignment.Center
                        c.HeaderName = "Second"
                        c.Width = 80
                        .Add(c)
                    End If
                    If True Then
                        Dim c As New TitleStructure
                        c.Align = HorizontalAlignment.Right
                        c.HeaderName = "Third"
                        c.Width = 110
                        .Add(c)
                    End If
                End With
                With .Values
                    .Clear()
                    .Add("Line1", New String() {"Line1.1", "Line1.2", "Line1.3"})
                    .Add("Line2", New String() {"Line2.1", "Line2.2", "Line2.3"})
                    .Add("Line3", New String() {"Line3.1", "Line3.2", "Line3.3"})
                    .Add("Line4", New String() {"Line4.1", "Line4.2", "Line4.3"})
                    .Add("Line5", New String() {"Line5.1", "Line5.2", "Line5.3"})
                End With
            End With
        End If
    End Sub

    Private Sub MultiColumnComboBox1_SelectedItemChangedByUser(ByVal sender As Object, ByVal e As System.EventArgs) Handles MultiColumnComboBox1.SelectedItemChangedByUser
        TextBox1.Text = MultiColumnComboBox1.SelectedID
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        MultiColumnComboBox1.Select("Line1", "Select Line1 (Init)")
    End Sub
End Class
